#include "pFlibs.inc"
#include "golds.inc"

background { color rgb 1/4 }
light_source { <  2,2,-2 >*10 color rgb 1 }
light_source { < -2,2,-2 >*10 color rgb 1 }
light_source { <  2,0, 2 >*10 color rgb 1 }
//vue_perspective( < 1.8,0.4,-0.9 >*1.5 )
vue_axonometrique( AXO, 0.4 )

#macro affichage( surf, avec_surf, avec_controles, avec_profils, k )
	#local N = taille(surf);
	#if (avec_surf)
		draw( 2, surf, finesse(<3,3>) + surface(LISSE) + ma_texture(MARBRE) )
	#end
	#if (avec_controles)
		#local i=0; #while (i<N)
			draw( 1, surf[i], finesse( 0 ) + le_point( 0.02 ) + ma_couleur( <1,0,0> ) )
			draw( 1, surf[i], finesse( 0 ) + courbe( 0.003 ) + ma_couleur( <1,1,0> ) )
		#local i=i+1; #end
	#end
	#if (avec_profils)
		#local i=0; #while (i<k*N)	// i<12
			#local couple = pFgetSubForm( 2, surf, i/(k*N-1) )
			draw( 1, couple, finesse(4) + courbe(0.006) + ma_couleur(<1,1,1>) )
		#local i=i+1; #end
	#end
#end

#local coque = array[6] 
{	array[5] { < 3/2,0,-1/32,1>, < 3/2,-1/4,-1/32,1>, < 3/2,-1/2,0,1>, < 3/2,-1/4,1/32,1>, < 3/2,0,1/32,1> },
	array[5] { < 2/2,0,-1/32,1>, < 2/2,-1/4,-1/32,1>, < 2/2,-1  ,0,1>, < 2/2,-1/4,1/32,1>, < 2/2,0,1/32,1> },
	array[5] { < 1/2,0,-1/16,1>, < 1/2,-1/2,-1/16,1>, < 1/2,-1  ,0,1>, < 1/2,-1/2,1/16,1>, < 1/2,0,1/16,1> },
	array[5] { < 0/2,0,-1/2 ,1>, < 0/2,-1/2,-2/2 ,1>, < 0/2,-1  ,0,1>, < 0/2,-1/2,2/2 ,1>, < 0/2,0,1/2 ,1> },
	array[5] { <-1/2,0,-1/2 ,1>, <-1/2,-1/2,-1/2 ,1>, <-1/2,-1/4,0,1>, <-1/2,-1/2,1/2 ,1>, <-1/2,0,1/2 ,1> },
	array[5] { <-2/2,0,-1/4 ,1>, <-2/2,-1/8,-1/4 ,1>, <-3/2,-1/8,0,1>, <-2/2,-1/8,1/4 ,1>, <-2/2,0,1/4 ,1> } 
}
#local coque2 = array[6] 
{	array[5] { < 3/2,0,-1/32,1>, < 3/2,1/32,-1/32,1>, < 3/2, 1/32,0,1>, < 3/2,1/32,1/32,1>, < 3/2,0,1/32,1> },
	array[5] { < 2/2,0,-1/32,1>, < 2/2,1/32,-1/32,1>, < 2/2, 1/32,0,1>, < 2/2,1/32,1/32,1>, < 2/2,0,1/32,1> },
	array[5] { < 1/2,0,-1/16,1>, < 1/2,1/32,-1/32,1>, < 1/2, 1/32,0,1>, < 1/2,1/32,1/32,1>, < 1/2,0,1/16,1> },
	array[5] { < 0/2,0,-1/2 ,1>, < 0/2,1/2 ,-1/16,1>, < 0/2, 4/2,0,1>, < 0/2,1/2,1/16 ,1>, < 0/2,0,1/2 ,1> },
	array[5] { <-1/2,0,-1/2 ,1>, <-1/2,-2/2,-1/2 ,1>, <-1/2, -2/2,0,1>, <-1/2,-2/2,1/2 ,1>, <-1/2,0,1/2 ,1> },
	array[5] { <-2/2,0,-1/4, 1>, <-2/2,-1/8,-1/4 ,1>, <-3/2,-1/8,0,1>, <-2/2,-1/8,1/4,1>, <-2/2,0,1/4,1> } 
}

union
{	affichage( coque,  true, true, true, 4 )
	affichage( coque2, true, true, true, 4 )
	object { cylinder { <0,-2/2,0>, <0,3/2,0>, 0.03 } pigment { color rgbt <1,1,1,0.5> } scale <2,1,1> }
	object { cylinder { <-2/2,1/4,0>, <3/2,1/4,0>, 0.01 } pigment { color rgbt <1,1,1,0.5> } }
	// rotate <0,360*39/40*clock,0>	// activer pour lancer le calcul d'une animation sur 40 vues
}
