///////////////////////////////////////////////////////////////
// tudes diverses 2005/2006 contenues dans pFcode_20051126.pov
///////////////////////////////////////////////////////////////


#macro _pSrenormalisation( surf )
	#local mm = taille(surf);
	#local nn = taille(surf[0]);
	#local rsurf = array[mm]
	#local i=0; #while (i<mm)
		#local temp = array[nn]
		#local j=0; #while (j<nn)
			#local temp[j] = pFgetPoint(1, surf[i], <j/(nn-1),0,0,1> )
		#local j=j+1; #end
		#local rsurf[i] = temp
	#local i=i+1; #end
	rsurf
#end

#macro pSrenormalisation( surf )
	#local mm = taille(surf);
	#local nn = taille(surf[0]);
	#local rsurf = array[mm]
	#local i=0; #while (i<mm)
		#local temp = array[nn]
		#local j=0; #while (j<nn)
			#local temp[j] = pFgetPoint(1, surf[i], <j/(nn-1),0,0,1> )
		#local j=j+1; #end
		#local rsurf[i] = temp
	#local i=i+1; #end
	#local rsurf = transpose_surface( rsurf )
	#local mm = taille(surf);
	#local nn = taille(surf[0]);
	#local rsurf = array[mm]
	#local i=0; #while (i<mm)
		#local temp = array[nn]
		#local j=0; #while (j<nn)
			#local temp[j] = pFgetPoint(1, surf[i], <j/(nn-1),0,0,1> )
		#local j=j+1; #end
		#local rsurf[i] = temp
	#local i=i+1; #end
	rsurf
#end

#macro workinprogress()
	#local dz =  -1/2;
	#local dd =  0/2;
	#local pS22 = array[2] { 	array[2] { <-1/2,-1/2, dz,1>, < 1/2,-1/2,-dz,1> }, 
								array[2] { <-dd, 1/2,-dz,1>, < 1/2, dd, dz,1> } }
	draw( 2, pS22, finesse( <4,4> ) + surface(LISSE) + ma_couleur( <1,1,1,0.3> ) )
/*
	#local ipS = array[2] { 	array[2] { <5/8,0/8,0,1>, <8/8,3/8,0,1> },
								array[2] { <0/8,5/8,0,1>, <6/8,8/8,0,1> } }
	#local ipS = array[3] { 	array[2] { <5/8,0/8,0,1>, <8/8,3/8,0,1> },
								array[2] { <4/8,3/8,0,1>, <6/8,5/8,0,1> },
								array[2] { <0/8,5/8,0,1>, <6/8,8/8,0,1> } }
*/
	#local ipS = array[3] { 	array[3] { <5/8,0/8,0,1>, <8/8,8/8,0,1>, <8/8,3/8,0,1> },
								array[3] { <4/8,3/8,0,1>, <4/8,4/8,0,1>, <6/8,5/8,0,1> },
								array[3] { <0/8,5/8,0,1>, <0/8,8/8,0,1>, <6/8,8/8,0,1> } }

	#local ipSS = ipS
//	#local ipSS = pSup( ipSS, <1,1> )	// ipS22 -> ipS33 -> 3+3-1 = 5
//	#local ipSS = pSup( ipSS, <2,1> )	// ipS32 -> ipS44 -> 4+4-1 = 7
	#local ipSS = pSup( ipSS, <2,2> )	// ipS33 -> ipS55 -> 5+5-1 = 9
//	#local ipSS = pSrenormalisation( ipSS )

	#local pS = pSlocal2global( ipSS, pS22 )

	draw( 2, pS, le_point(0.01) + ma_couleur( <0,1,0> ) )	// les points interpols

	#local pS = pSinterpolante( pS )

//	draw( 2, pS, le_point(0.01) + ma_couleur( <0,0,1> ) )
	draw( 2, pS, finesse( <4,4> ) + le_point(0.002) + ma_couleur( <0,0,0> ) )

	#local pL = pFdiagonalisation( 2, pS )
	draw( 1, pL, finesse( 3 ) + le_point(0.01) + ma_couleur( <1,0,0,0.5> ) )
	draw( 1, pL, finesse( 0 ) + le_point(0.02) + ma_couleur( <1,0,0> ) )

	// ipL4/pS22 = pL7 	(2+2-2)(4-1)+1=7
	#local ipL = pFdiagonalisation( 2, ipS )	// 3+2-1 = 4
	#local pL = courbe_in_surface( ipL, pS22 )
	draw( 1, pL, finesse( 3 ) + le_point(0.01) + ma_couleur( <1,1,1,0> ) )
	draw( 1, pL, finesse( 0 ) + le_point(0.02) + ma_couleur( <1,1,1,0> ) )

	#local pL = ipL	
	#local pL = pFsubdivision( 1, pL, <4,0,0,0> )
	pFimmersion( 2, pS22, 1, pL  )
	draw( 1, pL, le_point(0.02) + ma_couleur( <1,1,1,0.8> ) )
/*
	#local N = 10;	
	#local i=0; #while (i<N)
		#local ip = pFgetPoint( 2, ipS, <i/(N-1),i/(N-1),0,1> )
		#local p = pFgetPoint( 2, pS22, ip )
		draw( 0, p, le_point(0.03) + ma_couleur( <1,1,1,0> ) )
	#local i=i+1; #end
*/
#end
//workinprogress()

#macro ipL3_in_pS22()
// definition d'une pS22
	#local dz = -1/2;
	#local pS22 = array[2] { 	array[2] { <-1/2,-1/2, dz,1>, < 1/2,-1/2,-dz,1> }, 
								array[2] { <-1/2, 0/2,-dz,1>, < 0/2, 1/2, dz,1> } }
	draw( 2, pS22, finesse( <4,4> ) + surface(LISSE) + ma_couleur( <1,1,1,0.5> ) )
// definition d'une ipS22 dont ipL3 sera diagonale  
	#local ip00 = <4/8,0/8,0,1>;
	#local ip01 = <8/8,4/8,0,1>;

	#local ip10 = <0/8,4/8,0,1>;
	#local ip11 = <4/8,8/8,0,1>;

	#local ipS22 = array[2] { 	array[2] { ip00, ip01 }, 
								array[2] { ip01, ip11 } }
	#local ipL3 = pFdiagonalisation( 2, ipS22 )
// une ipS22/pS22 est une pS33, calcul de la ipS33 quivalente
	#local ipS33 = pSup( ipS22, <1,1> )
// passage  l'espace des 3x3 points de la ipS33
	#local pS33 = local2global( ipS33 )
// calcul de la pS33 interpolante et de sa diagonale pL5
	#local pS33 = pSinterpolante( pS33 )
	#local pL5 = pFdiagonalisation( 2, pS33 )
	draw( 2, pS33, finesse( <3,3> ) + le_point(0.005) + ma_couleur( <0,0,0,0.5> ) )
	draw( 1, pL5, finesse( 3 ) + le_point(0.005) + ma_couleur( <0,1,0> ) )
	draw( 1, pL5, finesse( 0 ) + le_point(0.01) + ma_couleur( <0,1,0> ) )

// controle avec la macro courbe_in_surface() :
	#local pL5 = courbe_in_surface( ipL3, pS22 )
	draw( 1, pL5, finesse( 3 ) + le_point(0.02) + ma_couleur( <1,1,0,0.7> ) )
	draw( 1, pL5, finesse( 0 ) + le_point(0.02) + ma_couleur( <1,0,0,0.7> ) )	

//  controle avec la macro pFimmersion(), rsultat  atteindre
	#local pL5 = ipL3	
	#local pL5 = pFsubdivision( 1, pL5, <4,0,0,0> )
	pFimmersion( 2, pS22, 1, pL5  )
	draw( 1, pL5, le_point(0.03) + ma_couleur( <1,1,1,0.8> ) )

// les deux courbes sont confondues, cqfd, le 08 oct 2005
#end
//ipL3_in_pS22()

///////////////////////////////////////////////////////////////
/*
//#local p= <1,2,3,4>;
//#debug concat( "p.x = ", str(p.x,0,0), "." )
// recherche de test sur array
#local tab = array[2][3]
#local ppp = <1,2,3>;
#ifdef (tab[0][0])
	#local dim = dimensions( tab );
#else
	#local dim = 0;
#end
#debug concat( "dimension tab = ", str(dim,0,0), "." )
*/
///////////////////////////////////////////////////////////////

#macro newdraw( dim, f, rayon )                
    // dessine les points de la pForme dans R3
    #if (dim=0)
        sphere { < f.x/f.t, f.y/f.t, f.z/f.t  >, rayon } 
    #else
        #local n = taille( f );
        #local i=0; #while (i< n)
            newdraw( dim-1, f[i], rayon )
        #local i=i+1; #end
    #end
#end

///////////////////////////////////////////////////////////////

//	3 MACROS INTERNES :

#macro newinterpol( p0, p1, uu )    // interpole deux points
	(1-uu)*p0 + uu*p1;
#end

#macro f2gd( in, uu ) 	
	// utilisation des globales : __gg, __dd, __nb_in, __ind
	// charge __gg et __dd, incremente __ind
	#local tt = taille( in );
	#if (tt>1)
		#local tab = array[tt-1]	// tableau des milieux
		#local i=0; #while (i<tt-1)
			#local tab[i] = newinterpol( in[i], in[i+1], uu )
		#local i=i+1; #end
		#declare __ind = __ind + 1;
		#declare __gg[__ind] = tab[0];
		#declare __dd[__nb_in-(__ind+1)] = tab[tt-2];
		f2gd( tab, uu )				// recursion jusqu'au point milieu
	#else	// le point milieu, jonction de gg et dd
		#declare __gg[__ind] = in[0];
		#declare __dd[__nb_in-(__ind+1)] = in[0];
	#end
#end

#macro blossom( in, r, uu ) 	
	// utilisation des globales : __out, __index
	// declaration des globales : __ind, __gg, __dd
	// charge __out, incremente __index
	#if (r>0)
		#local __ind = 0;
		#local __gg = in
		#local __dd = in
		f2gd( in, uu )
		#declare __out[__index] = in[0];
		#declare __index = __index + 1;
		blossom( __gg, r-1, uu )
		blossom( __dd, r-1, uu )
	#end
#end

//	3 MACROS FONDAMENTALES :

#macro calculer( in, r )	
	// produit 2^(r+1)+1 points egalement repartis sur in
	// declaration des globales : __nb_in, __out, __index
	#local R = r+1;
	#local __nb_in = taille(in);
    #local nb_out = pow(2, R)+1;
    #local __out = array[nb_out]
    #local __out[0] = in[0];
    #local __index = 1;
    blossom( in, R, 1/2 )	// corps recursif
    #local __out[nb_out-1] = in[__nb_in-1];
    __out
#end

#macro separer( in, uu )
	// produit un tableau de deux sous formes concatenees en uu
	// declaration des globales : __nb_in, __ind, __gg, __dd
	#declare __nb_in = taille(in);
	#local __ind = 0;
	#local __gg = in
	#local __dd = in
	f2gd( in, uu )
	array[2] { __gg, __dd }
#end

#macro fixer( in, u0, u1 )
	// fixe in entre u0 et u1
	#local tab0 = separer( in, u0 )			// d -> intervalle [u0,1]
	#local tab1 = separer( tab0[1], u1 )	// g -> intervalle [u0,u1]
	#local retour = tab1[0]
	retour
#end

///////////////////////////////////////////////////////////////

#macro test_1()
//#local pLN = array[2] { <-1,0,0,1>, < 1,0,0,1> } 
//#local pLN = array[3] { <-1,0,0,1>, < 0,1,0,1>, < 1,0,0,1> } 
//#local pLN = array[4] { 	<-1/2,-1/2,-1/2,1>, < 1/2,-1/2,-1/2,1>, < 1/2, 1/2,-1/2,1>, < 1/2, 1/2, 1/2,1> } 
#local pLN = demi_cercle_5( 1/2 )
#local k = 0.6;
#local pLN = pFstretch( 1, pLN, <-k,0,0,1>, <1+k,0,0,1> )

#local choix = 3;
#switch (choix)
#case (1)
	union { newdraw( 1, pLN, 0.04 ) pigment { color rgbt <1,1,1,0.5> } }
	#local spLN = calculer( pLN, 7 )
	union { newdraw( 1, spLN, 0.01 ) pigment { color rgbt <1,0,0,0> } }
#break
#case (2)
	#local tab = separer( pLN, 1/4 )
	#local gg = calculer( tab[0], 4 )
	#local dd = calculer( tab[1], 4 )
	union { newdraw( 1, gg, 0.04 ) pigment { color rgbt <0,1,0,0.5> } }
	union { newdraw( 1, dd, 0.03 ) pigment { color rgbt <0,0,1,0> } }
#break
#case (3)
	#local pLN = fixer( pLN, 1/4, 3/4 )
	union { newdraw( 1, pLN, 0.04 ) pigment { color rgbt <1,1,1,0.5> } }
	#local spLN = calculer( pLN, 5 )
	union { newdraw( 1, spLN, 0.02 ) pigment { color rgbt <1,0,0,0> } }	
#break
#end

#end

//test_1()

///////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////

#macro test( N )	// cercles concentriques immergs dans un tore
//	torus { 0.5, 0.249 pigment { color rgbt <1,1,1,0.5> } }
	#local c1 = demi_cercle_5( 0.25 ) 
	pFtranslate( 1, c1, <0.5,0,0> )		// section dans xOy
	#local c2 = demi_cercle_5( 1 )		// chemin dans xOz
	#local pS33 = cross( c1, c2 )
	#local pS33 = pFstretch( 2, pS33, <-0.0,-0.7,0,1>, <1.0,1.7,0,1> )
	pFrotate( 2, pS33, <0,-90,0> )
    draw( 2, pS33, finesse(<4,4>) + surface( LISSE ) + ma_couleur(<1,1,1,0.5>) )
	#local i=0; #while (i<N)
		#local uu = i/(N-1);
		#local pL5 = demi_cercle_4( (1-uu)*0.05 + uu*1.0 )
//		#local pL5 = pFstretch( 1, _pL5, <-0.5,0,0,1>, <1.5,0,0,1> )
		#local pL5_up = pL5
		#local pL5_down = pL5
    	pFrotate( 1, pL5_up, <0,0,180> )
    	pFtranslate( 1, pL5_up, <0.5,0.5,0> )
     	pFtranslate( 1, pL5_down, <0.5,0.5,0> )
 		#local ipL5_up = courbe_in_surface( pL5_up, pS33 )
		#local ipL5_down = courbe_in_surface( pL5_down, pS33 )
		draw( 1, ipL5_up, finesse(4) + courbe(0.01) + ma_couleur(<1,uu,0>) )
		draw( 1, ipL5_down, finesse(4) + courbe(0.01) + ma_couleur(<1,uu,0>) )
	#local i=i+1; #end
#end

//test( 5 )

#macro cerclesInPH( N )	
//	#local hh = 0.707;
	#declare pS22 = array[2] { 	array[2] { <-1/2,-1/2,-1/2,1>, < 1/2,-1/2,1/2,1> }, 
								array[2] { <-1/2, 1/2, 1/2,1>, < 1/2, 1/2,-1/2,1> } }
//	pFrotate( 2, pS22, <45,0,0> )
	draw( 2, pS22, finesse( <4,4> ) + surface(LISSE) + ma_couleur( <1,1,1,0.5> ) )
	#local i=0; #while (i<N)
	// definition d'un cercle :
	#local R = 1/2*i/(N-1) +0.001;
	#local iarc = demi_cercle_5( R )
	pFtranslate( 1, iarc, <1/2, 1/2, 0, 1> )
//	#local iarc = pFstretch( 1, iarc, <-hh,0,0,1>, <1+hh,0,0,1> )
	#local arc = courbe_in_surface( iarc, pS22 )
	draw( 1, arc, finesse( 3 ) + courbe(0.005) + ma_couleur( <i/(N-1),0,0> ) )
//
	pFtranslate( 1, iarc, <-1/2, -1/2, 0, 1> )
	pFrotate( 1, iarc, <0,0,180> )
	pFtranslate( 1, iarc, <1/2, 1/2, 0, 1> )
	#local arc = courbe_in_surface( iarc, pS22 )
	draw( 1, arc, finesse( 4 ) + courbe(0.005) + ma_couleur( <i/(N-1),0,0> ) )
//
	// definition d'un rayon :
	#local A = 2*pi*i/N;
	#local iray = array[2] { <0,0,0,1>, <1/2*cos(A),1/2*sin(A),0,1> }
	pFtranslate( 1, iray, <1/2, 1/2, 0, 1> )
	#local ray = courbe_in_surface( iray, pS22 )
	draw( 1, ray, finesse( 3 ) + courbe(0.005) + ma_couleur( <1,1,1> ) )
	#local i=i+1; #end
#end

// cerclesInPH( 12 )

#macro pL4from2pL3()
	#local p0 = <0.1,0.1,0.5,1>;	
	#local p1 = <0.9,0.5,-0.5,1>;
	#local p2 = <0.2,0.9,0.5,1>;
	#local p3 = <0.0,0.5,-0.5,1>;
	
	#local pL3_0 = array[3] { p0, p1, p2 }
	#local pL3_1 = array[3] { p1, p2, p3 }
	#local pS32 = array[2] { pL3_0, pL3_1  }
	#local pL4 = pFdiagonalisation( 2, pS32 )
	draw( 2, pS32, finesse( <4,4> ) + surface(LISSE) + ma_couleur( <1,1,1,0.8> ) )
	draw( 1, pL3_0, finesse( 4 ) + courbe(0.005) + ma_couleur( <1,0,0> ) )
	draw( 1, pL3_1, finesse( 4 ) + courbe(0.005) + ma_couleur( <0,1,0> ) )
	draw( 1, pL4, finesse( 4 ) + courbe(0.01) + ma_couleur( <1,1,1> ) )
#end

//pL4from2pL3()

#macro pL4from3pL2()
	#local p0 = <0.1,0.1,0.5,1>;
	#local p1 = <0.9,0.5,-0.5,1>;
	#local p2 = <0.2,0.9,0.5,1>;
	#local p3 = <0.0,0.5,-0.5,1>;
	
	#local pL2_0 = array[2] { p0, p1 }
	#local pL2_1 = array[2] { p1, p2 }
	#local pL2_2 = array[2] { p2, p3 }
	#local pS32 = array[3] { pL2_0, pL2_1, pL2_2  }
	#local pL4 = pFdiagonalisation( 2, pS32 )
	draw( 2, pS32, finesse( <4,4> ) + le_point(0.005) + ma_couleur( <1,1,1,0.8> ) )
	draw( 1, pL2_0, finesse( 4 ) + courbe(0.005) + ma_couleur( <1,0,0> ) )
	draw( 1, pL2_1, finesse( 4 ) + courbe(0.005) + ma_couleur( <0,1,0> ) )
	draw( 1, pL2_2, finesse( 4 ) + courbe(0.005) + ma_couleur( <0,0,1> ) )
	draw( 1, pL4, finesse( 4 ) + courbe(0.01) + ma_couleur( <1,1,1> ) )
#end

//pL4from3pL2()

/*
#macro test_immersion1( )	
	// il s'agit de verifier la propriete : ipl3/pS22 = diag(pS33) = pL5
	#declare pS22 = array[2] { 	array[2] { <-1/2,-1/2,-1/2,1>, < 1/2,-1/2,1/2,1> }, 
								array[2] { <-1/2, 1/2,1/2,1>, < 1/2, 1/2,0/2,1> } }
	draw( 2, pS22, finesse( <4,4> ) + surface(LISSE) + ma_couleur( <1,1,1,0.8> ) )
	// definition d'une parabole en local :
	#local p0 = <0.1,0.1,0,1>;
	#local p1 = <0.9,0.5,0,1>;
	#local p2 = <0.2,0.9,0,1>;
	// calcul direct de la pL5 equivalente :
	#local ipL3 = array[3] { p0, p1, p2 }
	#local pL3 = courbe_in_surface( ipL3, pS22 )
	draw( 1, pL3, finesse( 4 ) + courbe(0.02) + ma_couleur( <1,0,0,0.8> ) )
	draw( 1, pL3,  le_point(0.02) + ma_couleur( <1,0,0,0.5> ) )	
	// calcul indirect de la pL5 par une ipS33/pS22 avec pliage :
/*
		[20]	21	[22]		p1	.	p2		.	q3	.
		 10		11	 12			.	.	.		q1	q2	q3
		[00]	01	[02]		p0	.	p1		.	q1	.		
*/
	// definition des noeuds interpoles par la pS33 :
	// noeuds construits sur les points de la ipL3 :
	#local q0 = p0;
	#local q1 = (p0+p1)/2;
	#local q2 = (p0+2*p1+p2)/4;
	#local q3 = (p1+p2)/2;
	#local q4 = p2;
	// 
	#local ip00 = p0;
	#local ip02 = p1;
	#local ip20 = p1;
	#local ip22 = p2;
	#local ip01 = 	q1;
	#local ip10 = 	q1;
	#local ip11 = 	q2;
	#local ip12 = 	q3;
	#local ip21 = 	q3;
	// passage en global :
	#local pS33 = array[3] { array[3] { ip00, ip01, ip02 }, 
							 array[3] { ip10, ip11, ip12 }, 
							 array[3] { ip20, ip21, ip22 } }
	#local i=0; #while (i<3)
		#local j=0; #while (j<3)
			#local pS33[i][j] = pFgetPoint( 2, pS22, pS33[i][j] )
		#local j=j+1; #end
	#local i=i+1; #end
	// calcul de la pS33 interpolante et de sa diagonale :
	#local pS33 = pSinterpolante( pS33 )
	draw( 2, pS33, finesse( <3,3> ) + le_point( 0.005 ) + ma_couleur( <1,1,1> ) )
	#local pL5 = pFdiagonalisation( 2, pS33 )


	draw( 1, pL5, finesse( 4 ) + courbe(0.01) + ma_couleur( <0,0,1,0.5> ) )
	draw( 1, pL5,  le_point(0.01) + ma_couleur( <0,0,1,0> ) )	
	//	les deux courbes et leurs points de controle concordent
	//	de plus, la methode par pliage de la pS33 donne une expression dans R
	//	des points de controle de la pL5 (q0+4q1+6q2+4q3+q4)/16
	#local q0 =  pS33[0][0];
	#local q1 = (pS33[0][1]+pS33[1][0])/2;
	#local q2 = (pS33[0][2]+4*pS33[1][1]+pS33[2][0])/6;
	#local q3 = (pS33[1][2]+pS33[2][1])/2;
	#local q4 =  pS33[2][2];
	#local pL5 = array[5] { q0, q1, q2, q3, q4 }
	draw( 1, pL5, finesse( 4 ) + courbe(0.03) + ma_couleur( <0,1,0,0.8> ) )
	draw( 1, pL5,  le_point(0.03) + ma_couleur( <0,1,0,0.8> ) )
	// qui redonne bien la meme courbe
	// cqfd, dimanche 17 avril 2005
	// il reste a le demontrer dans le cas general : ipLN/pSmn = pLk avec k = (m+n-2)(N-1)+1
#end
*/

#macro test_immersion1( )	
#local kk = sqrt(2)/2;
	// il s'agit de verifier la propriete : ipl3/pS22 = diag(pS33) = pL5
/*
	#declare pS22 = array[2] { 	array[2] { <-1/2,-1/2,-1/2,1>, < 1/2,-1/2,1/2,1> }, 
								array[2] { <-1/2, 1/2,1/2,1>, < 1/2, 1/2,-1/2,1> } }
*/
	#declare pS22 = array[2] { 	array[2] { <-1/2,-1/2, 1/2,1>, < 1/2,-1/2,-1/2,1> }, 
								array[2] { <-1/2, 1/2,-1/2,1>, < 1/2, 1/2, 1/2,1> } }
	draw( 2, pS22, finesse( <4,4> ) + surface(LISSE) + ma_couleur( <1,1,1,0.5> ) )
	draw( 2, pS22, STANDARD )
	// definition d'une parabole en local :
/*
	#local p0 = <0.1,0.1,0,1>;	#local P0 = pFgetPoint( 2, pS22, p0 )	draw( 0, P0, le_point(0.03) )
	#local p1 = <0.9,0.5,0,1>;	#local P1 = pFgetPoint( 2, pS22, p1 )	draw( 0, P1, le_point(0.03) )
	#local p2 = <0.2,0.9,0,1>;	#local P2 = pFgetPoint( 2, pS22, p2 )	draw( 0, P2, le_point(0.03) )
*/
//	cas de l'arc de cercle :
	#local p0 = <1.0,0.5,0,1>;	#local P0 = pFgetPoint( 2, pS22, p0 )	draw( 0, P0, le_point(0.03) )
	#local p1 = <1.0,1.0,0,1>*kk;	#local P1 = pFgetPoint( 2, pS22, p1 )	draw( 0, P1, le_point(0.03) )
	#local p2 = <0.5,1.0,0,1>;	#local P2 = pFgetPoint( 2, pS22, p2 )	draw( 0, P2, le_point(0.03) )
	// calcul direct de la pL5 equivalente :	(2+2-2)(3-1)+1=5
	#local ipL3 = array[3] { p0, p1, p2 }

//  pFstretch() ne fonctionne pas :
  	#local N = 20;
	#local ipL3 = pFstretch( 1, ipL3, <-kk*N,0,0,1>, <1+kk*N,0,0,1> )
	
	#local pL3 = courbe_in_surface( ipL3, pS22 )
	draw( 1, pL3, finesse( 5 ) + courbe(0.005) + ma_couleur( <1,1,1> ) )
	draw( 1, pL3,  le_point(0.02) + ma_couleur( <1,1,1,0.5> ) )	
	// calcul indirect de la pL5 :
	// 1) dans pS22 construire la ipS22 sur [p0,p1] et [p1,p2]
	#local ipL2_0 = array[2] { p0, p1 }
	#local ipL2_1 = array[2] { p1, p2 }
	#local pL2_0 = courbe_in_surface( ipL2_0, pS22 )
	#local pL2_1 = courbe_in_surface( ipL2_1, pS22 )
	draw( 1, pL2_0, finesse( 4 ) + courbe(0.005) + ma_couleur( <1,1,1> ) )
	draw( 1, pL2_1, finesse( 4 ) + courbe(0.005) + ma_couleur( <1,1,1> ) )
	#local ipS22 = array[2] { ipL2_0, ipL2_1 }
	// 2) contruire la ipS33 quivalente et passer en global
	#local ipS = pSup( ipS22, <1,1> )	// ipS22 -> ipS33
//	#local ipS = pSup( ipS22, <2,0> )	// ipS22 -> ipS42 ne fonctionne pas
	#local i=0; #while (i<taille(ipS))
		#local j=0; #while (j<taille(ipS[0]))
			#local ipS[i][j] = pFgetPoint( 2, pS22, ipS[i][j] )
		#local j=j+1; #end
	#local i=i+1; #end
	// 3) calculer la pS interpolante et sa diagonale
	#local pS = pSinterpolante( ipS )
	#local pL5 = pFdiagonalisation( 2, pS )
	draw( 2, pS, finesse( <4,4> ) + le_point(0.005) + ma_couleur( <1,1,1> ) )
	draw( 1, pL5, finesse( 4 ) + courbe(0.02) + ma_couleur( <0,0,0,0.8> ) )
	draw( 1, pL5,  le_point(0.02) + ma_couleur( <0,0,0,0.5> ) )	
#end

//test_immersion1( )
//pLinterpolante_verif( 10 )
//pSinterpolante_verif( sqrt(2)/2*0.8 )

#macro test_immersion2( )	
	// il s'agit de verifier la propriete : ipl3/pS22 = diag(pS33) = pL5
	#declare pS22 = array[2] { 	array[2] { <-1/2,-1/2,-1/2,1>, < 1/2,-1/2,1/2,1> }, 
								array[2] { <-1/2, 1/2,1/2,1>, < 1/2, 1/2,0/2,1> } }
	draw( 2, pS22, finesse( <4,4> ) + surface(LISSE) + ma_texture( MARBRE ) )
	// definition d'une parabole en local :
	#local p0 = <0.1,0.1,0,1>;
	#local p1 = <0.9,0.5,0,1>;
	#local p2 = <0.2,0.9,0,1>;
	#local p3 = <0.0,0.5,0,1>;
	// calcul direct de la pL7 equivalente :	(2+2-2)(4-1)+1=7
	#local ipL4 = array[4] { p0, p1, p2, p3 }
	#local pL4 = courbe_in_surface( ipL4, pS22 )
	draw( 1, pL4, finesse( 4 ) + courbe(0.005) + ma_couleur( <1,1,1> ) )
	draw( 1, pL4,  le_point(0.02) + ma_couleur( <1,1,1,0.5> ) )	
	
	#local ipL2_0 = array[2] { p0, p1 }
	#local ipL2_1 = array[2] { p1, p2 }
	#local ipL2_2 = array[2] { p2, p3 }

	#local pL2_0 = courbe_in_surface( ipL2_0, pS22 )
	#local pL2_1 = courbe_in_surface( ipL2_1, pS22 )
	#local pL2_2 = courbe_in_surface( ipL2_2, pS22 )
	draw( 1, pL2_0, finesse( 4 ) + courbe(0.005) + ma_couleur( <1,1,1> ) )
	draw( 1, pL2_1, finesse( 4 ) + courbe(0.005) + ma_couleur( <1,1,1> ) )
	draw( 1, pL2_2, finesse( 4 ) + courbe(0.005) + ma_couleur( <1,1,1> ) )

	// calcul indirect de la pL7 :
	// 1) dans pS22 construire une ipS sur ipL2_0, ipL2_1, ipL2_2
	#local ipS = array[3] { ipL2_0, ipL2_1, ipL2_2 }
	// 2) elever le degre pour une diag de 7 et passer en global
	#local ipS = pSup( ipS, <0,3> )		// 0,3

	#local i=0; #while (i<taille(ipS))
		#local j=0; #while (j<taille(ipS[0]))
			#local ipS[i][j] = pFgetPoint( 2, pS22, ipS[i][j] )
		#local j=j+1; #end
	#local i=i+1; #end

	// 3) calculer la pS interpolante et sa diagonale
	#local pS = pSinterpolante( ipS )
	#local pL7 = pFdiagonalisation( 2, pS )
	draw( 2, pS, finesse( <2,5> ) + le_point(0.002) + ma_couleur( <1,1,1> ) )
	draw( 1, pL7, finesse( 4 ) + courbe(0.01) + ma_couleur( <1,0,0,0.5> ) )
	draw( 1, pL7,  le_point(0.02) + ma_couleur( <1,1,0,0.5> ) )	
#end

//test_immersion2( )


//////////////////////////////////////////////////////////////////////

#macro arcs_struct( R, r, N )
	#local pProfil = arc_cercle( 5, r)	
	pFtranslate( 1, pProfil, <R,0,0> )
	#local pChemin = arc_cercle( 5, -1)
	#local pSurf = cross( pProfil, pChemin )

	pFtranslate( 0, pSurf[2][1], <0,1/1,0> )		
	pFtranslate( 0, pSurf[2][3], <0,-1/1,0> )		

	draw( 2, pSurf, finesse( <3,5> ) + surface( LISSE ) + ma_texture( MARBRE ) )
	#local i=0; #while (i<N)
		#local uu = i/(N-1)*3/4;
		#local geo1 = geodesique( pSurf, <uu,0,0,1>, 75, 30, 1/100 )
		draw( 1, geo1, finesse(0) + courbe( 0.005 ) + ma_couleur( <1,0,0> ) )
		#local geo2 = geodesique( pSurf, <uu,0,0,1>, 105, 30, 1/100 )
		draw( 1, geo2, finesse(0) + courbe( 0.005 ) + ma_couleur( <0,1,0> ) )
	//	tracer_normales_geodesique( geo1, 0.025, 0.003 )
	//	tracer_normales_geodesique( geo2, 0.025, 0.003 )
	#local i=i+1; #end
	union 
	{ 
	draw( 2, pSurf, finesse( <3,5> ) + surface( LISSE ) + ma_texture( MARBRE ) )

	#local i=0; #while (i<N)
		#local uu = i/(N-1)*3/4;
		#local geo1 = geodesique( pSurf, <uu,0,0,1>, 75, 30, 1/100 )
		draw( 1, geo1, finesse(0) + courbe( 0.005 ) + ma_couleur( <1,0,0> ) )
		#local geo2 = geodesique( pSurf, <uu,0,0,1>, 105, 30, 1/100 )
		draw( 1, geo2, finesse(0) + courbe( 0.005 ) + ma_couleur( <0,1,0> ) )
	//	tracer_normales_geodesique( geo1, 0.025, 0.003 )
	//	tracer_normales_geodesique( geo2, 0.025, 0.003 )
	#local i=i+1; #end
	 rotate <0,180,0> 
	 }
#end

//arcs_struct( 0.5, 0.2, 16 )	// 1, 16, 32
//union { arcs_struct( 0.4, 0.5, 32 ) translate <0,-1.1,0> rotate <90,0,0> } 


#macro test_pSinterpolante() // pS35 interpolante
	#local pL3 = array[3] { <-1/2, 0,-1/2,1>, < 0, 0,-1/2,1>, < 1/2, 0,-1/2,1> }
	#local pL3_0 = pL3 pFtranslate( 1, pL3_0, <0,0,0/4> ) pFtranslate( 0, pL3_0[1], <0,0,-1/4> )
	#local pL3_1 = pL3 pFtranslate( 1, pL3_1, <0,0,1/4> ) pFtranslate( 0, pL3_1[1], <0,-1/4,0> )
	#local pL3_2 = pL3 pFtranslate( 1, pL3_2, <0,0,2/4> ) pFtranslate( 0, pL3_2[2], < 1/8,0,0> )
	#local pL3_3 = pL3 pFtranslate( 1, pL3_3, <0,0,3/4> ) pFtranslate( 0, pL3_3[1], <0, 1/4,0> )
	#local pL3_4 = pL3 pFtranslate( 1, pL3_4, <0,0,4/4> ) pFtranslate( 0, pL3_4[1], <0,0, 1/4> )
	#local pS35 = array[5] { pL3_0, pL3_1, pL3_2, pL3_3, pL3_4 }

	draw( 2, pS35, finesse(<0,0>) + le_point(0.04) + ma_couleur(<1,0,0>) )
	#local pS35 = pSinterpolante( pS35 )
	#local pS35 = pFstretch( 2, pS35, <-0.06,-0.06,0,1>, <1.06,1.06,0,1> )
	draw( 2, pS35, finesse(<4,4>) + surface(LISSE) + ma_texture(GOLD) )
	#local pL7 = pFdiagonalisation( 2, pS35 )
	#local pL7 = pFstretch( 1, pL7, <-0.3,0,0,1>, <1.01,0,0,1> )
	draw( 1, pL7, finesse(6) + courbe(0.01) + ma_couleur(<1,1,0>) )
#end

//test_pSinterpolante()




#macro _cross( c1, c2 )
    #local nb1 = taille( c1 );    	// courbes chemin
    #local nb2 = taille( c2 );    	// courbe section
    #local surf = array[nb1]    	// surface produite
    #local i = 0; #while (i< nb1) 	// pour chaque point du profil
        #local profil = c1[i];		// un point du profil
        #local pp = array[nb2]
        #local j=0; #while (j< nb2)	// pour chaque pt  section
            #local section = c2[j];	// un pt de la section
        	#local pp[j] = <	section.x * profil.x,    // base sur x
              					section.t * profil.y,    // le long de l'axe y
              					section.y * profil.x,    // base sur z
              					section.t * profil.t  >  ;    
       	#local j=j+1; #end
        #local surf[i] = pp
    #local i=i+1; #end
    surf
#end

#macro vase()
	#local cc1 = array[7] { <0.01,-0.50,0,1>,
							<0.10,-0.50,0,1>,
							<0.50,-0.50,0,1>*50,
							<0.50,-0.25,0,1>,
							<0.10, 0.00,0,1>*50,
							<0.10, 0.50,0,1>,
							<0.15, 0.50,0,1>
						} 	// section dans xOy	
	pFtranslate( 1, cc1, <1/4,0,0> )	
	#local cc2 = quart_cercle_3( 1,1 )
	#local cc2 = demi_cercle_5( 1 )
	#local pS33 = _cross( cc1, cc2 )
  	draw( 1, cc1, finesse(4) + courbe(0.01) + ma_couleur(<0,1,0,0>) )
   	draw( 2, pS33, finesse(<3,3>) + surface(LISSE) )
#end
//vase()

#macro quart_tore()
	#local R1=0.5;
	#local R2=0.2;
	#local k = 1/sqrt(2);
/*	
	#local pTore = array[3]
	#local i=0; #while (i<3)
		#local c2 = array[3] { <R2,0,0,1>, <R2,R2,0,1>*k, <0,R2,0,1> }
		pFtranslate( 1, c2, <R1,0,0> )
		pFrotate( 1, c2, <0,-90*i/2,0> )
		//draw( 1, c2, courbe(0.01) + ma_couleur( <0,1,1> ) )
		//draw( 1, c2, finesse( 3 ) + courbe(0.01) + ma_couleur( <0,0,1> ) )
		#local tt = array[3]
		#local j=0; #while (j<3)
			#local tt[j] = pFgetPoint( 1, c2, <j/2,0,0,1> )
			//draw( 0, tt[j], STANDARD )
		#local j=j+1; #end
		#local pTore[i] = tt
	#local i=i+1; #end
	#local ipTore = pSinterpolante( pTore )
	#local h = 1;
	#local ipTore = pFstretch( 2, ipTore, <0,-h,0,1>, <1,1+h,0,1> )
  	draw( 2, ipTore, ma_couleur(<0,1,0> ) )
	draw( 2, ipTore, finesse( <3,3> ) + surface(LISSE) + ma_couleur( <0,1,0,0.5> ) )
*/
/*
   	#local arc = array[3] 
        {
		< 0,   0, -R2, 1 >,
		< 0,  R2, -R2, 1 >*k,
		< 0,  R2,   0, 1 >
        }
	#local arc0 = arc
	pFtranslate( 1, arc0, <0,0,-R1> )
 
   	#local arc1 = arc 
	pFrotate( 1, arc1, <0,45,0> )
	pFscale( 1, arc1, <1/k,1,1/k> )

  	#local arc1[0] = arc1[0]*k;
	#local arc1[1] = arc1[1]*k;
	#local arc1[2] = arc1[2]*k;

  	pFtranslate( 1, arc1, <R1,0,-R1> )

	#local arc2 = arc	
	pFtranslate( 1, arc2, <0,0,-R1> )
	pFrotate( 1, arc2, <0,90,0> )

	#local qtore = array[3] { arc0, arc1, arc2 }
//	#local h = 3;
//	#local qtore = pFstretch( 2, qtore, <0,0,0,1>, <1,1+h,0,1> )
   	draw( 2, qtore, ma_couleur(<1,1,1> ) )
	draw( 2, qtore, finesse( <4,4> ) + le_point(0.005) + ma_couleur( <1,1,1> ) )
*/

  	#local arc = array[3] 
        {
		< 0,   0, -R2, 1 >,
		< 0,  R2, -R2, 1 >*k,
		< 0,  R2,   0, 1 >
        }
	#local b = array[3]
	#local b[0] = pFgetPoint( 1, arc, <0/2,0,0,1> )
	#local b[1] = pFgetPoint( 1, arc, <1/2,0,0,1> )
	#local b[2] = pFgetPoint( 1, arc, <2/2,0,0,1> )
	
	#local b0 = b	pFtranslate( 1, b0, <0,0,-R1> )	pFrotate( 1, b0, <0,0,0> )
	#local b1 = b	pFtranslate( 1, b1, <0,0,-R1> )	pFrotate( 1, b1, <0,45,0> )
	#local b2 = b	pFtranslate( 1, b2, <0,0,-R1> )	pFrotate( 1, b2, <0,90,0> )

	#local qtore = array[3] { b0, b1, b2 }
	#local qtore = pSinterpolante( qtore )
//	#local h = 3;
//	#local qtore = pFstretch( 2, qtore, <0,0,0,1>, <1,1+h,0,1> )
   	draw( 2, qtore, ma_couleur(<1,1,1> ) )
	draw( 2, qtore, finesse( <4,4> ) + le_point(0.005) + ma_couleur( <1,1,1> ) )

	torus { 0.5, 0.2 pigment { color rgb <1,0,0> } scale 0.999 }
#end

//quart_tore()


#macro decalage_R3(chemin, d)
	#local n = taille(chemin);
	#local delta = array[n]
	// calcul de n repres de frenet :
	#local i = 0; #while (i< n)
		// calcul du repere de Frenet au point de controle i :
		// recalage de la courbe en i  :
		#local uu = i/(n-1);
		#local ff = pFstretch( 1, chemin, uu, uu+1 )
		// p0, p1 et p2 sont accessibles, calcul dans R3 :
		#local p0 = < ff[0].x/ff[0].t,ff[0].y/ff[0].t,ff[0].z/ff[0].t >;
		#local p1 = < ff[1].x/ff[1].t,ff[1].y/ff[1].t,ff[1].z/ff[1].t >;
		#local p2 = < ff[2].x/ff[2].t,ff[2].y/ff[2].t,ff[2].z/ff[2].t >;
		// et donc le repre de Frenet :
		#local tt = p1-p0;
		#local bb = vcross( tt, (p2-p0) );
		#local tt = vnormalize( tt );
		#local bb = vnormalize( bb );
		#local nn = vcross( bb, tt );
		// calcul du deplacement dans R3 et dans le repere de Frenet :
		#local dd = <d.x/d.t, d.y/d.t, d.z/d.t>;
		#local ddd = <	nn.x*dd.x + bb.x*dd.y + tt.x*dd.z ,
					nn.y*dd.x + bb.y*dd.y + tt.y*dd.z ,
					nn.z*dd.x + bb.z*dd.y + tt.z*dd.z  >;
		// calcul et deplacement du noeud i dans R3 :
		#local delta[i] = pFgetPoint( 1, chemin, <i/(n-1),0,0,1> ) 
		pFtranslate( 0, delta[i], ddd )
	#local i=i+1; #end
	// on a les noeuds de delta, on calcule les points de controle :
	pLinterpolante( delta )
#end

#macro _pipo()
	#local k = sqrt(2)/2;
	#local h = k*0.9;
	#local r2 = 1/4;
	#local r1 = 1/2;
	#local cc2 = array[4] { <0,0,0,1>, <-r2,0,0,1>, <-r2,r2,0,1>, <0,r2,0,1> }
	#local cc2 = demi_cercle_4( r2 )
//	#local cc2 = pFstretch( 1, cc2, <-h,0,0,1>, <1+h,0,0,1> )	
	#local c1 = demi_cercle_5( r1 ) 
//	#local c1 = pFstretch( 1, c1, <-h,0,0,1>, <1+h,0,0,1> )
//	#local c1 = decalage_R3(c1, cc2[0] )
	#local c2 = decalage_R3(c1, cc2[1] )
	#local c3 = decalage_R3(c1, cc2[2] )
	#local c4 = decalage_R3(c1, cc2[3] )	
	#local surf = array[5] { 
				 array[4] { c1[0], c2[0], c3[0], c4[0] },
				 array[4] { c1[1], c2[1], c3[1], c4[1] },
				 array[4] { c1[2], c2[2], c3[2], c4[2] },
				 array[4] { c1[3], c2[3], c3[3], c4[3] },
				 array[4] { c1[4], c2[4], c3[4], c4[4] }}
union {
	//draw( 1, c1, finesse(0) + le_point(0.02) +  ma_couleur(<1,1,1>) )
	draw( 1, c1, finesse(4) + courbe(0.01) +  ma_couleur(<1,1,1>) )
	//draw( 1, c2, finesse(0) + le_point(0.02) +  ma_couleur(<1,1,0>) )
	draw( 1, c2, finesse(4) + courbe(0.01) +  ma_couleur(<1,0,0>) )
	//draw( 1, c3, finesse(0) + le_point(0.02) +  ma_couleur(<1,1,0>) )
	draw( 1, c3, finesse(4) + courbe(0.01) +  ma_couleur(<0,1,0>) )
	//draw( 1, c4, finesse(0) + le_point(0.02) +  ma_couleur(<1,1,0>) )
	draw( 1, c4, finesse(4) + courbe(0.01) +  ma_couleur(<0,0,1>) )
	draw( 2, surf, finesse( <0,0> ) + le_point(0.05) + ma_couleur(<1,0,0>))
	draw( 2, surf, finesse( <3,3> ) + surface(LISSE) + ma_couleur(<1,1,0,0.0>))
	rotate <90,0,0>//	translate <0,r2/2,0>
	}	
	object { torus { 1/2, 1/4 } pigment { color rgb <1,1,1, 0.8> } }
#end

//_pipo()

#macro pipo()
	#local k =  sqrt(2)/2;
	#local h1 = k*0.9;
	#local h2 = k*0.4;
	#local r2 = 1/4;
	#local r1 = 1/2;
	#local cc2 = demi_cercle_4( r2 )
//	#local cc2 = pFstretch( 1, cc2, <-h2,0,0,1>, <1+h2,0,0,1> )
	
	#local c1 = demi_cercle_5( r1 ) 
//	#local c1 = pFstretch( 1, c1, <-h1,0,0,1>, <1+h1,0,0,1> )
//	#local c1 = decalage_R3(c1, cc2[0] )
	#local c2 = decalage_R3(c1, cc2[1] )
	#local c3 = decalage_R3(c1, cc2[2] )
	#local c4 = decalage_R3(c1, cc2[3] )
	
	#local surf = array[5] { 
				 array[4] { c1[0], c2[0], c3[0], c4[0] },
				 array[4] { c1[1], c2[1], c3[1], c4[1] },
				 array[4] { c1[2], c2[2], c3[2], c4[2] },
				 array[4] { c1[3], c2[3], c3[3], c4[3] },
				 array[4] { c1[4], c2[4], c3[4], c4[4] }}

	draw( 1, cc2, finesse(4) + courbe(0.01) +  ma_couleur(<0,0,0>) )
union {
	draw( 1, c1, finesse(0) + le_point(0.02) +  ma_couleur(<1,1,1>) )
	draw( 1, c1, finesse(4) + courbe(0.01) +  ma_couleur(<1,1,1>) )
	draw( 1, c2, finesse(0) + le_point(0.02) +  ma_couleur(<1,1,0>) )
	draw( 1, c2, finesse(4) + courbe(0.01) +  ma_couleur(<1,0,0>) )
	draw( 1, c3, finesse(0) + le_point(0.02) +  ma_couleur(<1,1,0>) )
	draw( 1, c3, finesse(4) + courbe(0.01) +  ma_couleur(<0,1,0>) )
	draw( 1, c4, finesse(0) + le_point(0.02) +  ma_couleur(<1,1,0>) )
	draw( 1, c4, finesse(4) + courbe(0.01) +  ma_couleur(<0,0,1>) )
//	draw( 2, surf, finesse( <0,0> ) + le_point(0.05) + ma_couleur(<1,0,0>))
	draw( 2, surf, finesse( <3,3> ) + surface(LISSE) + ma_couleur(<1,1,0,0.5>))
	rotate <90,0,0>
}
//	object { torus { 1/2, 1/4 } pigment { color rgb <1,1,1, 0.8> } rotate <90,0,0> }
	
#end
//	pipo()

#macro test_decalage_R3()
	#local R1 = 1/2;
	#local R2 = 1/4;
	#local k = sqrt(2)/2;
	#local h = k; // 2.4 0.8;
	#local c1 = demi_cercle_5( R1 ) 
	pFrotate( 1, c1, <-90,0,0> )
//	pFtranslate( 0, c1[0], <0,-1/2,0> )
//	pFtranslate( 0, c1[4], <0, 1/2,0> )
//	#local c1 = pFstretch( 1, c1, <-h,0,0,1>, <1+h,0,0,1> )
//	draw( 1, c1, finesse(0) + le_point(0.02) +  ma_couleur(<1,1,1>) )
	draw( 1, c1, finesse(4) + courbe(0.01) +  ma_couleur(<1,1,1>) )

	// calcul d'une distribution sur un demi-cercle :
	#local c2 = demi_cercle_5( R2 )
//	#local c2 = pFstretch( 1, c2, <-h,0,0,1>, <1+h,0,0,1> )
	#local n = taille( c2 );
	#local cc = c2
	#local i=0; #while (i<n)
		#local cc[i] = pFgetPoint( 1, c2, <i/(n-1),0,0,1> )
	#local i=i+1; #end
	#local c2 = cc

	// calcul des lignes // :
	#local surf = array[n]
	#local i=0; #while (i<n)
		// calcul des le_point s de controle et affichage des //
		#local c3 = decalage_R3(c1, c2[i])		
		draw( 1, c3, finesse( 3 ) + courbe(0.005) + ma_couleur(<1,1,0>))
//		draw( 1, c3, finesse( 0 ) + le_point(0.02) + ma_couleur(<1,1,0>))
			// calcul des noeuds des //
			#local c4 = c3
			#local j=0; #while (j<n)
				#local c4[j] = pFgetPoint( 1, c3, <j/(n-1),0,0,1> )				
				draw( 0, c4[j], le_point(0.02) + ma_couleur(<1,0,0>))
			#local j=j+1; #end
		#local surf[i] = c4
	#local i=i+1; #end
	// calcul des sections :
	#local _surf = array[n]
	#local i=0; #while (i<n)
		#local tt = array[n]
		#local j=0; #while (j<n)
			#local tt[j] = surf[j][i];
		#local j=j+1; #end
		#local _surf[i] = pLinterpolante( tt )
		draw( 1, _surf[i], finesse( 3 ) + courbe(0.005) + ma_couleur(<0,1,0>))
//		draw( 1, _surf[i], finesse( 0 ) + le_point(0.02) + ma_couleur(<0,1,0>))
	#local i=i+1; #end

	#local surf = pSinterpolante( surf )
//	draw( 2, surf, finesse( <3,3> ) + surface(LISSE) + ma_couleur(<0,1,1,0.8>))
	draw( 2, surf, finesse( <0,0> ) + le_point(0.02) + ma_couleur(<0,1,1,0.8>))
//	object { torus { R1, R2 } pigment { color rgb <1,1,1, 0.8> } }
#end
//	test_decalage_R3()


/*	
	ANALYSE DE PIPE()
	resultat : instable sous pFstretch() si le chemin est rationnel
*/
#macro _new_pipe(chemin, section)
	#local vmax = taille(chemin);
	#local umax = taille(section);
	#local tube = array[vmax]
	// pour chaque le_point de controle du chemin :
	#local i = 0; #while (i< vmax)	
		// recalage sur le le_point i :
		#local uu = i/(vmax-1);
		#local ff = pFstretch( 1, chemin, uu, uu+1 )
		// on a accs aux le_point s p0, p1 et p2 :
		#local p0 = < ff[0].x/ff[0].t,ff[0].y/ff[0].t,ff[0].z/ff[0].t >;
		#local p1 = < ff[1].x/ff[1].t,ff[1].y/ff[1].t,ff[1].z/ff[1].t >;
		#local p2 = < ff[2].x/ff[2].t,ff[2].y/ff[2].t,ff[2].z/ff[2].t >;
		// calcul du repre de frenet dans R3 :
		#local tt = p1-p0;
		#local bb = vcross( tt, (p2-p0) );
		#local tt = vnormalize( tt );
		#local bb = vnormalize( bb );
		#local nn = vcross( bb, tt );
		// on prepare le calcul en local de la section :
		#local sect = array[umax]
		// calcul du noeud i du chemin dans R4 :
		#local sss = pFgetPoint( 1, chemin, <i/(vmax-1),0,0,1> )
		// pour chaque le_point de controle de la section :
		#local j=0; #while (j<umax)
			// au dpart on est au noeud i du chemin :
			#local sect[j] = sss;	
			// calcul du noeud j de la section dans R4 qui reprsente 
			// le dplacement  appliquer au noeud j de la section :
			#local d = pFgetPoint( 1, section, <j/(umax-1),0,0,1> )
			// passage dans R3 et dans le repre de Frenet :
			#local dd = <d.x/d.t, d.y/d.t, d.z/d.t>;
			#local ddd = <	nn.x*dd.x + bb.x*dd.y + tt.x*dd.z,
						nn.y*dd.x + bb.y*dd.y + tt.y*dd.z,
						nn.z*dd.x + bb.z*dd.y + tt.z*dd.z >;
			// translation de ddd du noeud du chemin :
			pFtranslate( 0, sect[j], ddd )
		#local j=j+1; #end
		// les noeuds de la section sont definis :
		#local tube[i] = sect
	#local i=i+1; #end
	// on a les noeuds du tube, on calcule les le_point s de controle :
	pSinterpolante( tube )
#end

#macro new_pipe(chemin, section)
	#local vmax = taille(chemin);
	#local umax = taille(section);
	#local tube = array[vmax]
	#local sect = array[umax]
	#local i = 0; #while (i< vmax)
		#local mat = pLgetFrenet( chemin, i/(vmax-1) )
		#local j = 0; #while (j< umax)
			#local d = pFgetPoint( 1, section, <j/(umax-1),0,0,1> )
			#local sect[j] = pFtransform( mat, d );			
		#local j=j+1; #end
		#local tube[i] = sect
	#local i=i+1; #end
	pSinterpolante( tube )
#end

#macro analyse_pipe()
	#local R1 = 1/2;
	#local R2 = 1/16;
//	#local cc1 = demi_cercle_5( R1 )	
// 	essai sur une version non rationnelle :
    	#local p0 = <  R1, 0,      0, 1 >;
    	#local p1 = <  R1, R1,     0, 1 >;
    	#local p2 = <  0, 3/2* R1, 0, 1 >;
    	#local p3 = < -R1, R1,     0, 1 >;
    	#local p4 = < -R1, 0,      0, 1 >;
    	#local cc1 = array[5] { p0, p1, p2, p3, p4 }

		pFtranslate( 0, cc1[0], <0,0,2/2> )
		pFtranslate( 0, cc1[4], <0,0,-2/2> )		
	#local cc2 = demi_cercle_5( R2 ) 

	#local h1 = sqrt(2)/2 * 7/8;
	#local h2 = sqrt(2)/2;
//	#local cc1 = pFstretch( 1, cc1, <-h1,0,0,1>, <1+h1,0,0,1> )	// doesn't work
//	#local cc2 = pFstretch( 1, cc2, <-h2,0,0,1>, <1+h2,0,0,1> )	// does work
	#local tore = new_pipe( cc1, cc2 )	// tubage de section cc2 sur chemin cc1
//	#local tore = pFstretch( 2, tore, <0,-h1,0,1>, <1,1+h1,0,1> )	// doesn't work
//	#local tore = pFstretch( 2, tore, <-h2,0,0,1>, <1+h2,1,0,1> )	// does work
	#macro obj( rx, ry )
	union 
	{	draw( 1, cc1, finesse(5) + courbe(R2*0.99) + ma_couleur( <1,1,1> ) )
		draw( 2, tore, finesse( <3,5> ) + surface(LISSE) + ma_couleur(<1,0,0,0.5>))
		rotate <rx,ry,0>
	}
	#end
	obj(90,-90)		
	obj(90,-90)	
	obj(180,-90)	
	obj(270,-90)
#end

// analyse_pipe()





